'---------------------------------------------------------------------------
'Zentrum fuer Fuzzy- & InformationsTechnik GmbH
'Baumhofweg 4
'D-44267 Dortmund
'
'Copyright (C) by ZeTec
'All rights reserved.

'Dieser Basic-Code wurde automatisch mit der FCU generiert und beinhaltet
'den gesamten Algorithmus zur Berechnung des Fuzzy-Reglers.
'---------------------------------------------------------------------------

                         'Erfuellungsgrade = Efgs

DEFINE Summe_Efg    WORD 'Summe aller Efgs
DEFINE Rest_Summe   WORD 'Summe der Reste der Divisionen
DEFINE Rest_Dummy   WORD 'Speicher fuer die Reste der Divisionen
DEFINE Aus_Wert     BYTE 'Ausgangswert
DEFINE Akt_Efg      BYTE 'Efg der akt. Regel
DEFINE Min_Efg      BYTE 'min Efg. der akt. Regel
DEFINE Reg_Anzahl   BYTE 'Anzahl der Regeln
DEFINE Akt_Regel    BYTE 'Nummer der aktuellen Regel
DEFINE Set_Param    BYTE 'Zeiger auf die Paremetertabelle                         'Erfuellungsgrade = Efgs

DEFINE A            BYTE 'Parameter A eines Fuzzy-Sets
DEFINE B            BYTE 'Parameter B eines Fuzzy-Sets
DEFINE C            BYTE 'Parameter C eines Fuzzy-Sets
DEFINE D            BYTE 'Parameter D eines Fuzzy-Sets
DEFINE Eingang      BYTE 'Eingangswert
DEFINE Akt_Eing     BYTE 'akt. Eingang

'---------------------------------------------------------------------------
'Definitionen der externen Ein- und Ausgaenge

DEFINE Eingang_1        AD[5]    'Eingangsbyte (0...255)
DEFINE Eingang_2        AD[6]    'Eingangsbyte (0...255)

define Eingang_3        byte     'Zeiteingang
define Ausgang    	DA[1]
Define Relais           port[7]  'Relais 1
'---------------------------------------------------------------------------

'---------------------------------------------------------------------------
'In dieser Endlosschleife wird der Regleralgorithmus abgearbeitet

#ANFANG
  Eingang_3 = (hour*255)/24
  LOOKTAB Fuzzy_Sets, 0, Reg_Anzahl        'Anzahl der Regeln lesen
  Reg_Anzahl = Reg_Anzahl-1                'Schleife beginnt mit 0 !

  Summe_Efg =  0
  Aus_Wert =   0
  Rest_Summe = 0
  Rest_Dummy = 0

  '---------------------------------------
                                           'Bildung der Summe der Erfuellungsgrade
  FOR Akt_Regel = 0 TO Reg_Anzahl

    Akt_Efg = 0
    Min_Efg = 100

    FOR Akt_Eing = 0 TO 2                  'Schleife ueber die Eingaenge

      IF Akt_Eing = 0 THEN Eingang = Eingang_1

      IF Akt_Eing = 1 THEN Eingang = Eingang_2

      IF Akt_Eing = 2 THEN Eingang = Eingang_3

                                           'Eingangswerte zuordnen

      Set_Param = 13 * Akt_Regel + Akt_Eing * 4 + 1
      LOOKTAB Fuzzy_Sets, Set_Param, A     'Parameter A laden
      IF A > Eingang THEN GOTO FOR_ENDE_1  'EFG = 0

      Set_Param = Set_Param + 3
      LOOKTAB Fuzzy_Sets, Set_Param, D     'Parameter D laden
      IF D < Eingang THEN GOTO FOR_ENDE_1  'EFG = 0

      Set_Param = Set_Param - 2
      LOOKTAB Fuzzy_Sets, Set_Param, B     'Parameter B laden

      Set_Param = Set_Param + 1
      LOOKTAB Fuzzy_Sets, Set_Param, C     'Parameter C laden

      Akt_Efg = 100

      IF Eingang < B THEN GOSUB EFG_LINKS  'linke Flanke

      IF Eingang > C THEN GOSUB EFG_RECHTS 'rechte Flanke

    NEXT

    Summe_Efg = Summe_Efg + Min_Efg        'Summe der Efgs

    #FOR_ENDE_1
  NEXT                                     'Ende Schleife 1(Summe des EFGs bilden)

  IF Summe_Efg = 0 THEN GOTO ANFANG        'keine Regel erfuellt
                                           'dann alten Ausgangswert beibehalten
  '---------------------------------------
                                           'Fuzzifizierung der Eingangswerte und
                                           'Berechnung der neuen Ausgangswerte

  FOR Akt_Regel = 0 TO Reg_Anzahl

    Akt_Efg = 0
    Min_Efg = 100

    FOR Akt_Eing = 0 TO 2                  'Schleife ueber die Eingaenge

      IF Akt_Eing = 0 THEN Eingang = Eingang_1

      IF Akt_Eing = 1 THEN Eingang = Eingang_2

      IF Akt_Eing = 2 THEN Eingang = Eingang_3

                                           'Eingangswerte zuordnen

      Set_Param = 13 * Akt_Regel + Akt_Eing * 4 + 1
      LOOKTAB Fuzzy_Sets, Set_Param, A     'Parameter A laden
      IF A > Eingang THEN GOTO FOR_ENDE_2  'EFG = 0

      Set_Param = Set_Param + 3
      LOOKTAB Fuzzy_Sets, Set_Param, D     'Parameter D laden
      IF D < Eingang THEN GOTO FOR_ENDE_2  'EFG = 0

      Set_Param = Set_Param - 2
      LOOKTAB Fuzzy_Sets, Set_Param, B     'Parameter B laden

      Set_Param = Set_Param + 1
      LOOKTAB Fuzzy_Sets, Set_Param, C     'Parameter C laden

      Akt_Efg = 100

      IF Eingang < B THEN GOSUB EFG_LINKS  'linke Flanke

      IF Eingang > C THEN GOSUB EFG_RECHTS  'rechte Flanke

    NEXT

    Set_Param = 13 * Akt_Regel + 13
    LOOKTAB Fuzzy_Sets, Set_Param, A       'Paramter A des Ausg.-Fuzzy-Sets laden

    Aus_Wert=Aus_Wert+(A*Min_Efg)/Summe_Efg
                                           'Anteil dieser Regel am neuen
                                           'Ausgangswert berechnen

    Rest_Dummy = Rest_Dummy + (A * Min_Efg) MOD Summe_Efg
                                           'Reste der Divisionen aufsummieren
    IF Rest_Dummy < 0 THEN GOSUB ZWISCHEN_REST ELSE Rest_Summe = Rest_Dummy
                                           'Ueberlauf der Summe abfangen
   #FOR_ENDE_2
  NEXT
  '---------------------------------------  Ende Schleife 2

  Aus_Wert = Aus_Wert + Rest_Summe / Summe_Efg
                                           'Korrekturwert und Ausgangswert                                           'addieren
 '*************
 'Variable_?? = Aus_Wert   'Aus_Wert = neuer Ausgangswert(0...255)
 '*************
 Ausgang = Aus_Wert
 If Aus_Wert > 127 then Relais = 1
 If Aus_Wert < 127 then Relais = 0                                          '

GOTO ANFANG                                'Sprung zum Anfang
'---------------------------------------------------------------------------
'Ende der Endlosschleife

END                                        'Programmende

             'Unterprogramme
'------------------------------------------
'Fuzzyfizierung der linken Fuzzy-Set-Flanke
#EFG_LINKS                                 'EFG an der linke Flanke berechnen
  Akt_Efg = (Eingang - A) * 100 / (B- A)
  IF Akt_Efg < Min_Efg THEN Min_Efg = Akt_Efg
                                           'neuen kleinsten EFG speichern
RETURN                                     'Ruecksprung

'-------------------------------------------
'Fuzzyfizierung der rechten Fuzzy-Set-Flanke
#EFG_RECHTS                                'EFG an der rechten Flanke berechnen
  Akt_Efg = 100 - (Eingang - C) * 100 / (D - C)
  IF Akt_Efg < Min_Efg THEN Min_Efg = Akt_Efg
                                           'neuen kleinsten EFG speichern
RETURN
                                     'Ruecksprung
'-------------------------------------------
'Datenueberlauf Summe der Reste behandeln
#ZWISCHEN_REST
  Rest_Summe = Rest_Summe / Summe_Efg
  Aus_Wert = Aus_Wert + Rest_Summe         'Ausgangswert korrigieren
  Rest_Dummy = (A * Min_Efg) MOD Summe_Efg 'neuen Rest_1 bilden
  Rest_Summe = Rest_Summe MOD Summe_Efg    'neuen Rest_2 bilden
  Rest_Summe = Rest_Summe + Rest_Dummy
RETURN                                     'Ruecksprung
'-------------------------------------------

TABLE Fuzzy_Sets                           'Regeltabelle
8
0   0   80  100
0   0   255 255
64  64  234 234 255
0   0   255 255
0   0   55  105
64  64  234 234 255
80  100 255 255
0   0   255 255
64  64  234 234 0
0   0   255 255
55  105 255 255
64  64  234 234 0
0   0   70  90
0   0   255 255
0   0   64  64  255
0   0   70  90
0   0   255 255
234 234 255 255 255
70  90  255 255
0   0   255 255
0   0   64  64  0
70  90  255 255
0   0   255 255
234 234 255 255 0
